## Java code of the examples of Lecture 5

In this directory you can find different folders corresponding to the different examples we discuss in the Lecture and how to execute them (tested in a Linux machine).

### gate

It contains two files:

* Counter.java - The counter example with the data race occurring when updating the variable `counter`.

* CounterS.java - The solution to the data race in the counter example using semaphores.

* Counter.jad - The output of the decompiler `jad` executed on Counter.class that shows the origin of the data race in Counter.java.

* run.sh - A small shell script to run the program 10 times.

To run the examples you only need to compile the corresponding file

`javac Counter.java`

and executing the class with the main method

`java Counter`

If you also want to run the `jad` (it can be downloaded [here](https://varaneckas.com/jad/)), you need to first compile `Counter.java` and afterwards execute

`jad -af Counter.class`

it will generate the file Counter.jad.

You can run several instances in one go by calling `./run.sh className`, where
className is either Counter or CounterS

### gate-time

Follow the same instructions as for gate. The only difference is that now you will see in the output the time it takes for the thread to finish its execution.

### people

It contains three files:

* Counter.java - A different instantiation of the counter example where we create 10 threads that will update `counter`. In this case we want the queue of the semaphore to always be empty. However, the solution in this file does not enforce this property because it uses availablePermits() and afterwards acquires the semaphore. DO NOT USE availablePermits() in the lab.

* CounterS.java - This file contains the solution to the previous problem, we use tryAcquire() instead of availablePermits() which makes atomic checking and acquiring the semaphore.

* run.sh - A small shell script to run the program 10 times.

You can compile the files as defined above. For running it you can use the
`./run.sh className` (where className is either Counter or CounterS) or the `java` commands described above.

---------------
Author: Raúl Pardo
Modifications: Alexander Sjösten
