import java.util.concurrent.Semaphore; // Semaphores library for Java

class CounterS {
    int counter = 0;
    final int PEOPLE = 10000;
    Semaphore sem = new Semaphore(1); // Semaphore to control acccess to counter (these semaphores are not binary)

    public CounterS() {
        try {
            Gate east = new Gate();
            Gate west = new Gate();

            east.start();
            west.start();
            east.join();
            west.join();

            System.out.println("counter = " + counter);

        } catch (InterruptedException e) {
            System.out.println(e);
        }

    }

    public static void main(String[] args) {
        new CounterS();
    }

    class Gate extends Thread {
        public void run() {
            try {
                for (int i = 0; i < PEOPLE; i++) {
                    sem.acquire(); // Enter critical section
                    counter++;     // Update shared variable
                    sem.release(); // Leave critical section
                }
            } catch (InterruptedException e) {
                System.out.println(e);
            }
        }
    }
}
