import java.util.concurrent.Semaphore;

class Counter3 {
    int counter = 0;
    int PEOPLE = 10;
    Semaphore sem = new Semaphore(1);

    public Counter3() {
        try {
            Person[] person = new Person[PEOPLE];
            for (int i = 0; i < PEOPLE; i++) {
                person[i] = new Person();
                person[i].start();
            }

            for (int i = 0; i < PEOPLE; i++) {
                person[i].join();
            }

            System.out.println("counter = " + counter);

        } catch (InterruptedException e) {
            System.out.println(e);
        }

    }

    public static void main(String[] args) {
        new Counter3();
    }

    class Person extends Thread {
        public void run() {
            boolean enter = false;
            while(!enter) {

                /*
                 * Check if there is anyone in the queue,
                 * if not enter, i.e., acquire the semaphore
                 * (everything is done atomically)!
                 */
                if (sem.tryAcquire()) {
                    // Note that now we do not need to execute `sem.acquire()`
                    // It was acquire when calling `tryAcquire()`
                    System.out.println("The lenght of the queue is " + sem.getQueueLength());
                    counter++;
                    sem.release(); // Release critical section
                    enter = true;
                } else {
                    // Going for a coffee and come back later
                    // sleep(500);
                }
            }
        }
    }
}
